////////////////////////////////////////////////////////////////////////////////
//  DebugDraw2D.vsh
//  Debug Draw 2D vertex shader
//
//  Created by Bojan Endrovski on 23/09/2010.
//  Copyright Bojan Endrovski 2010. All rights reserved.
////////////////////////////////////////////////////////////////////////////////


// Vertex atributes
attribute vec2 position;		// Vertex atribute
attribute vec4 color;			// Vertex atribute

// From vertex shader to fragment
varying vec4 colorVarying;		

// Constants (aka uniforms)
uniform mat3 u_projection;      // Camera projection


void main()
{	
    // For dbg reasons
    gl_PointSize = 2.0;
    
    // Calculate 2D position
    vec3 pos3   = vec3(position, 1.0);  // expand to homogeneous
    pos3 = u_projection * pos3;         // project
    
	gl_Position = vec4(pos3, 1.0);
    
	// Just transfer color
    colorVarying = color;
}
