////////////////////////////////////////////////////////////////////////////////
//  DebugDraw2D.vsh
//  Debug Draw 2D vertex shader
//
//  Created by Bojan Endrovski on 23/09/2010.
//  Copyright Game Oven 2013. All rights reserved.
////////////////////////////////////////////////////////////////////////////////


// Vertex atributes
attribute vec3 a_position;
attribute vec4 a_color;

// From vertex shader to fragment
varying vec4 v_color;

// Constants (aka uniforms)
uniform mat4 u_worldviewproj;      // Camera projection


void main()
{	
    // For dbg reasons
    gl_PointSize = 3.0;
    
    // Calculate 2D position
    //    vec3 pos3   = vec3(position, 1.0);  // expand to homogeneous
    // pos3 = u_projection * pos3;         // project
    
	// gl_Position = vec4(pos3, 1.0);
    
    gl_Position = u_worldviewproj * vec4(a_position, 1.0);
    
	// Just transfer color
    v_color = a_color;
}
