//
//  Particles2D.vsh
//  Vertex shader for transforming 2D particles
//
//  Created by Bojan Endrovski on 23/09/2010.
//  Copyright Bojan Endrovski 2010. All rights reserved.
//


// Vertex atributes
attribute vec3 a_position;		// X,Y position, Z stores size!
attribute vec4 a_color;			// Vertex atribute

// From vertex shader to fragment
varying vec4 v_color;
 
// Constants (aka uniforms)
uniform mat3    u_projection;   // Camera projection
uniform float   u_zoom;         // Camera zoom

void main()
{        
    // Calculate 2D position
    vec3 pos3   = vec3(a_position.xy, 1.0);     // expand to homogeneous
    pos3 = u_projection * pos3;                 // project
    
    // Just transfer texture coords
    v_color = a_color;
    
    // Write position
    gl_Position = vec4(pos3, 1.0);
    
    // Write size
    gl_PointSize = a_position.z * u_zoom;    
}
