//
//  Particles3D.vsh
//  Vertex shader for transforming 2D particles
//
//  Created by Bojan Endrovski on 23/09/2010.
//  Copyright Bojan Endrovski 2010. All rights reserved.
//


// Vertex atributes
attribute vec4 a_position;		// X,Y, Z position, W stores size!
attribute vec4 a_color;			// Vertex atribute

// From vertex shader to fragment
varying vec4 v_color;
 
// Constants (aka uniforms)
uniform mat4    u_worldviewproj;   // Camera projection
uniform float   u_zoom;             // Camera zoom

void main()
{        
    // Calculate 2D position
    vec4 pos4   = vec4(a_position.xyz, 1.0);     // expand to 3D homogeneous
    pos4 = u_worldviewproj * pos4;               // project
    
    // Just transfer texture coords
    v_color = a_color;
    
    // Write position
    gl_Position = pos4;
    
    // Write size
    gl_PointSize = a_position.w; // * u_zoom;
}
