//////////////////////////////////////////////////////////////////////////////////
//  Sprite.vsh
//  Simple sprite drawing
//
//  Created by Bojan Endrovski on 23/09/2010.
//  Copyright Bojan Endrovski 2010. All rights reserved.
//////////////////////////////////////////////////////////////////////////////////

// Input from vertex shader
varying lowp    vec2    v_texture;
varying mediump vec2    v_position;

// Texture sampler
uniform sampler2D       s_texture;

// Uniforms
uniform lowp    vec4    u_tint;             // Tint the output color

void main()
{
    // Sample color texture
    lowp vec4 color = texture2D(s_texture, v_texture);
    color *= u_tint;

    // Sepia
    // lowp float c = (color.r + color.g + color.b) * 0.4;
    // lowp vec4 bw = vec4(c + 0.1, c + 0.1, c, color.a);
    // gl_FragColor = mix(color, bw, 0.8);
    gl_FragColor = color;
}