//////////////////////////////////////////////////////////////////////////////////
//  Sprite.vsh
//  Simple sprite drawing
//
//  Created by Bojan Endrovski on 23/09/2010.
//  Copyright Bojan Endrovski 2010. All rights reserved.
//////////////////////////////////////////////////////////////////////////////////


// Vertex atributes
attribute vec2 a_position;
attribute vec2 a_texture;

// From vertex shader to fragment
varying vec2 v_position;
varying vec2 v_texture;

// Constants (aka uniforms)
uniform mat3 u_projection;      // Camera projection
uniform mat3 u_world;           // World matrix

void main()
{	    
    // Calculate 2D position
    vec3 pos3   = vec3(a_position, 1.0);    // expand to homogeneous
    pos3 = u_projection * u_world * pos3;   // project
    
    gl_Position = vec4(pos3, 1.0);
    
    // Just transfer texture coords
    v_texture = a_texture;
}
