//////////////////////////////////////////////////////////////////////////////////
//  Svg.vsh
//  Simple gradient polygon drawing
//  TODO: different gradients than linear.
//
//  Created by Gerard Meier on 21/07/2013.
//  Copyright Game Oven 2013. All rights reserved.
//////////////////////////////////////////////////////////////////////////////////


// Vertex atributes
attribute vec2 a_position;
attribute vec4 a_color;

// From vertex shader to fragment
varying vec4 v_color;

// Constants (aka uniforms)
uniform mat3 u_projection;      // Camera projection
uniform mat3 u_world;           // World matrix

void main()
{
    // Calculate 2D position
    vec3 pos3   = vec3(a_position, 1.0);    // expand to homogeneous
    pos3 = u_projection * u_world * pos3;   // project
    
    gl_Position = vec4(pos3, 1.0);
    
    // Just transfer color. At the time of writing, C++ already
    // calculated the correct color per vertex. TODO: perhaps
    // the shader could do this, too?
    v_color = a_color;
}
